% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grading_functions.R
\name{givePoints}
\alias{givePoints}
\title{Compute points obtained for each student}
\usage{
givePoints(corrections, MC.key, correct = 1, wrong = 0, type = "SC")
}
\arguments{
\item{corrections}{data frame with info on whether students ticked correct answer (TRUE/FALSE)}

\item{MC.key}{data frame with solutions and grouping info}

\item{correct}{number of points for each correct answer}

\item{wrong}{number of points for each wrong answer}

\item{type}{'SC' for single choice, 'SC-capped' for single choice capped at zero
points per exercise from below or 'kprim'; in 'kprim' there must be 4 answers per question. 
If you have all 4 correct, you get 2 points; if you have 3 out of 4 correct, you get 1 point.
Otherwise, you get 0 points. I.e., 'correct' and 'wrong' is not used in this option. NA is counted as wrong answer.}
}
\value{
data frame with points per student (both for groups of excercises unter 'points_' and total under 'pointsTotal')
}
\description{
Compute points obtained for each student
}
