library(sfsGrading)
## for testing correctMC()
## INPUT: answers (df, from MC.answers), solutions (df, from MC.key), MC.prefix (string, e.g. 'TICKED:')
## It is assumed that 'answers' has columns of the form 'TICKED:A1' and as entry the ticked value (e.g. 'A' or 'B')
## 'solutions' has column 'Exercise' with unique exercise labels (e.g. 'A1') and column 'CorrectAnswer' with correct answer (e.g. 'A' or 'B')

ind <- paste0("A", 1:8)
## create key: only 'Exercise' and 'CorrectAnswer' is needed for this test
MC.key <- data.frame(Exercise = ind,
                     CorrectAnswer = c('A', 'B', 'B', 'A', 'B', 'A', 'B', 'AC'),
                     Index = c(rep(1,4), rep(2,4)))

MC.prefix <- "TICKED:"

## create student answers
MC.answers <- data.frame(tmp1 = rep(999, 8))
correctionsMat <- rbind(c('A', 'A', 'A', 'A', 'B', 'B', 'B', 'B'),
                        c('A', 'A', 'A', 'B','B', 'B', 'B', 'A'),
                        c('A', 'A', 'B', 'A','B', 'B', 'A', 'B'),
                        c('A', 'A', 'B', 'B','B', 'B', 'A', 'A'),
                        c('A', 'B', 'A', 'A', 'B', 'A', 'B', 'B'),
                        c('A', 'B', 'A', 'B','B', 'A', 'B', 'A'),
                        c('A', 'B', 'B', 'A','B', 'A', 'A', 'B'),
                        c('A', 'B', 'B', 'B','B', 'A', 'A', 'A'),
                        c('', '', 'AB', 'XY', 'B', 'B', 'A', 'C'),
                        c('A', 'B', 'B', 'A','B', 'A', 'A', 'AC'),
                        c('A', 'B', 'B', 'A','B', 'A', 'A', 'BC'),
                        c('A', 'B', 'B', 'A','B', 'A', 'A', 'ABC'))
corrections <- as.data.frame(cbind(101:(100+nrow(correctionsMat)), rep('XYZ',nrow(correctionsMat)), correctionsMat))
colnames(corrections) <- c('number', 'NotUsed', paste0(MC.prefix,ind))

## undebug(correctMC)
res <- correctMC(answers = corrections, solutions = MC.key, MC.prefix = MC.prefix)

## check output
stopifnot(is.na(res$MC.corrections$A1[9]), is.na(res$MC.corrections$A2[9])) 
## after checking NAs at appropriate positions, remove them to facilitate comparison
res$MC.corrections$A1[9] <- res$MC.corrections$A2[9] <- TRUE
stopifnot(
  res$MC.corrections$A1 == c(rep(TRUE, 12)),
  res$MC.corrections$A2 == c(FALSE, FALSE, FALSE, FALSE, TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE),
  res$MC.corrections$A3 == c(FALSE, FALSE, TRUE,  TRUE,  FALSE, FALSE, TRUE,  TRUE,  FALSE, TRUE,  TRUE,  TRUE),
  res$MC.corrections$A4 == c(TRUE,  FALSE, TRUE,  FALSE, TRUE,  FALSE, TRUE,  FALSE, FALSE, TRUE,  TRUE,  TRUE),
  res$MC.corrections$A5 == c(TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE),
  res$MC.corrections$A6 == c(FALSE, FALSE, FALSE, FALSE, TRUE,  TRUE,  TRUE,  TRUE,  FALSE, TRUE,  TRUE,  TRUE),
  res$MC.corrections$A7 == c(TRUE,  TRUE,  FALSE, FALSE, TRUE,  TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, FALSE),
  res$MC.corrections$A8 == c(FALSE, TRUE,  FALSE, TRUE,  FALSE, TRUE,  FALSE, TRUE,  TRUE,  TRUE,  FALSE, FALSE),
  res$numberTicked == c(rep(8, 8), 6, rep(8, 3))
)

          
          
          