library(sfsGrading)
## for testing givePoints() and points.ex()
## It is assumed that the subproblems are already evaluated and compared 
## correctly with MC.key$CorrectAnswer; this results in a dataframe "corrections" with TRUE/FALSE entries.
## Now we have to test, that the points are given for correct answers in the right way.

ind <- LETTERS[1:8]
## create key: only Index is needed for this test, CorrectAnswer is ignored!
MC.key <- data.frame(Exercise = ind,
                     CorrectAnswer = c(TRUE, FALSE, FALSE, FALSE, TRUE, TRUE, FALSE, FALSE),
                     Index = c(rep(1,4), rep(2,4)))

## create student answers
## two exercises with 4 problems each; generate all 16 combination (2 per row, corresponding to an excercise)
## the last row simulates missing entries
correctionsMat <- rbind(c(TRUE, TRUE, TRUE, TRUE, FALSE, FALSE, FALSE, FALSE),
                     c(TRUE, TRUE, TRUE, FALSE,FALSE, FALSE, FALSE, TRUE),
                     c(TRUE, TRUE, FALSE, TRUE,FALSE, FALSE, TRUE, FALSE),
                     c(TRUE, TRUE, FALSE, FALSE,FALSE, FALSE, TRUE, TRUE),
                     c(TRUE, FALSE, TRUE, TRUE, FALSE, TRUE, FALSE, FALSE),
                     c(TRUE, FALSE, TRUE, FALSE,FALSE, TRUE, FALSE, TRUE),
                     c(TRUE, FALSE, FALSE, TRUE,FALSE, TRUE, TRUE, FALSE),
                     c(TRUE, FALSE, FALSE, FALSE,FALSE, TRUE, TRUE, TRUE),
                     c(TRUE, NA, FALSE, FALSE,FALSE, TRUE, TRUE, NA))
corrections <- as.data.frame(correctionsMat)
colnames(corrections) <- ind

## SC, 1/0
cor1 <- givePoints(corrections = corrections, MC.key = MC.key, correct = 1, wrong = 0, type = "SC")
stopifnot(all(cor1$points_1 == c(4,3,3,2,3,2,2,1,1)),
          all(cor1$points_2 == c(0,1,1,2,1,2,2,3,2)),
          all(cor1$pointsTotal == c(rep(4,8),3)))

## SC, 1/-0.5
cor2 <- givePoints(corrections = corrections, MC.key = MC.key, correct = 1, wrong = -0.5, type = "SC")
stopifnot(cor2$points_1 == c(4, 2.5, 2.5, 1, 2.5, 1, 1, -0.5, 0),
          cor2$points_2 == c(-2, -0.5, -0.5, 1, -0.5, 1, 1, 2.5, 1.5),
          cor2$pointsTotal == c(rep(2,8), 1.5))

## kprim
## T⁴: 2 points, F*T³: 1 points, otherwise: 0 points
cor3 <- givePoints(corrections = corrections, MC.key = MC.key, correct = 1, wrong = 0, type = "kprim")
stopifnot(all(cor3$points_1 == c(2,1,1,0,1,0,0,0,0)),
          all(cor3$points_2 == c(0,0,0,0,0,0,0,1,0)),
          all(cor3$pointsTotal == c(2,1,1,0,1,0,0,1,0)))

## SC-capped
cor3 <- givePoints(corrections = corrections, MC.key = MC.key, correct = 1, wrong = -1, type = "SC-capped")
stopifnot(all(cor3$points_1 == c(4,2,2,0,2,0,0,0,0)),
          all(cor3$points_2 == c(0,0,0,0,0,0,0,2,1)),
          all(cor3$pointsTotal == c(4,2,2,0,2,0,0,2,1)))